;copyright 2002 by Samuel Stearley



	include "os.h"
	xdef _ti89
	xdef _ti92plus
	xdef _nostub
	xdef _main


_main:
	movem.l d3-d7/a2-a6,-(a7);save registers
	move.l $C8,a5		;get the jump table
	move.l 2976(a5),a6	;get the push_between rom call
	move.l 1060(a5),a4	;this is where top_estack is stored in ram
	move.l (a4),a2		;get top_estack
	lea 2444(a5),a3
	move.l (a3)+,a0
	move.l (a3),a3
	jsr (a0)		;push the end_list tag
	move.l a2,d4		;initiate variable "source", a2 is "ptr"
	move.l a7,d5

;----The while loop------------

GoToNextTag:
	move.b (a2),d3		;get top tag
	cmp.b #45,d3		;is it a var name, int, float, ect?
	bhi MustBeAnOperator
UseNextExpressionIndex:
	move.l a2,-(a7)		;push the esi
	move.l 1064(a5),a0	;get next expression index
	jsr (a0)
	move.l a0,a2		;ptr = next_expression_index(ptr);
	cmp.b #27,d3		;so is it a var name?
	bhi PopEm
	move.l 3780(a5),a0
	jsr (a0)		;get the call that checks if it is a unit
	tst.b d0
	bne PopEm
	move.l (a4),-(a7)	;push top_estack
	move.l 2932(a5),a0
	jsr (a0)		;see if it is already in the list
	tst.w d0
	beq PopEm		;branch if it is already in the list
	move.l a2,(a7)
	jsr (a6)		;put it to the list
PopEm
	move.l d5,a7
	bra	GoToNextTag	;go on to the next tag
MustBeAnOperator:
DoSubtract:
	subq.l #1,a2		;decriment the esi
	cmp.b #$da,d3		;basic function tag?
	beq	UseNextExpressionIndex
	sub.b #$e3,d3		;if ext_tag then d3 =0 if ext_instr_tag d3 =1
	subq.b #1,d3		;check if it is 1 or 0
	bls DoSubtract		;if so the decriment again
	subq.b	#5,d3		;is it the end of estack tag?
	bne GoToNextTag

;----Done now return the list--------

	jsr (a3)		;push the list tag
	move.l (a4),-(a7)	;get top estack
	addq.l	#1,a2
	move.l a2,(a4)		;top_estack =bottom_estack;
	move.l d4,-(a7)
	jsr (a6)		;move the output list to the bottom of the estack
	addq.l #8,a7		;  so that it can be used in expressions.
	movem.l (a7)+,d3-d7/a2-a6
	move.l (a7)+,a0		;get the return address, this is part of the
	cmpi.w #$21EE,(a0)	;  return value hack.
	bne.s __A2
	addq.l #2,a0
__A2:
	jmp 4(a0)


	END	
